#include "dcdialog.ch"
#include "dctree.ch"
#include "dcmsg.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "nls.ch"
#include "dll.ch"


procedure main
SET CHARSET TO OEM
SET CONFIRM ON
SET DELETE ON
SET SCORE OFF

DO EXAMPLE

return


PROC appsys ; RETURN


PROCEDURE EXAMPLE
LOCAL aPos:={0,0},aSize:={0,0}

PRIVATE oDialog,oDarea
PRIVATE oBrowse,oColumn,lStatus,lOFFcursor


aSize:={ 700,500 }
aPos[1]:=10
aPos[2]:=100

oDialog := XbpDialog():New(,, aPos, aSize )
oDialog:Title := "EXAMPLE"
oDialog:minSize:=aSize
oDialog:maxSize:=aSize
oDialog:sysMenu:=.F.
oDialog:hideButton:=.F.
oDialog:border := XBPDLG_THINBORDER
oDialog:Create()

// trick to hide min,max button
oDialog:maxButton:=.F.
oDialog:minButton:=.F.
oDialog:configure()

SetAppFocus(oDialog)
oDarea:=oDialog:drawingArea

lOFFcursor:=.F.

USE ("TEST.DBF") ALIAS DBCLIF NEW
dbgotop()

@  1,1 DCBROWSE oBrowse SIZE 95,18 ID "BROWSE" ;
            CURSORMODE XBPBRW_CURSOR_ROW ALIAS "DBCLIF" ;
            PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },;                    /// Header FG Color
                                  { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND },;               /// Header BG Color
                                  { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },;                   /// Footer FG Color
                                  { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },;                 /// Footer BG Color
                                  { XBP_PP_COL_DA_CELLHEIGHT, 20 }} ;                         /// Cell Height
             NOSIZECOLS
            *EDIT xbeBRW_ItemSelected MODE DCGUI_BROWSE_EDITDOWN


    DCBROWSECOL FIELD DBCLIF->FIELD_4 Header "field4"   WIDTH 30 PARENT oBrowse OBJECT oColumn
    DCBROWSECOL FIELD DBCLIF->FIELD_1 Header "field1"   WIDTH 5 PARENT oBrowse
    DCBROWSECOL FIELD DBCLIF->FIELD_3 Header "field3"   WIDTH 10 PARENT oBrowse
    DCBROWSECOL FIELD DBCLIF->FIELD_2 Header "field2"   WIDTH 15 PARENT oBrowse

@ 20,1 DCPUSHBUTTON CAPTION "CURSOR ROW ON/OFF" OBJECT oButton1 ;
                    ACTION {||ON_OFF_CURSOR(GetList)} SIZE 25,2 PARENT oWindow TABSTOP


DCGETOPTIONS NOBUSY CONFIRM NOMINBUTTON NOMAXBUTTON NOTASKLIST NORESIZE


DCREAD GUI TO lStatus OPTIONS GetOptions PARENT oDarea ; // ENTEREXIT ;
       SETFOCUS "BROWSE"

RETURN



STATIC FUNCTION ON_OFF_CURSOR (GetList)
IF lOFFcursor // view cursor
    lOFFcursor:=.F.

    oBrowse:hilite()
    AEval( oBrowse:aColumns, {|o| o:Redraw() } ) // redraw columns

/*
    oBrowse:cursorMode := XBPBRW_CURSOR_ROW
    oBrowse:configure()
    oBrowse:hilite()
    oBrowse:forceStable()
    oBrowse:refreshCurrent()
    SetAppFocus(oBrowse)
*/
ELSE // hide cursor
    lOFFcursor:=.T.

    oBrowse:deHilite()
    AEval( oBrowse:aColumns, {|o| o:Redraw() } ) // redraw columns

/*
    oBrowse:cursorMode := XBPBRW_CURSOR_NONE
    oBrowse:configure()
    oBrowse:dehilite()
    oBrowse:forceStable()
    oBrowse:refreshCurrent()
    SetAppFocus(oBrowse)
*/


    *oBrowse:cursorMode := XBPBRW_CURSOR_NONE
    *oBrowse:configure()
    *AEval( oBrowse:aColumns, {|o| o:DataArea:setCell( oBrowse:RowPos, NIL ) } ) // clear data ROW
    *oBrowse:refreshCurrent()
    *oBrowse:HiliteColumns ( oBrowse:RowPos, .f., .f. )
    *oBrowse:forceStable()

ENDIF
RETURN NIL


